
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

using namespace std;
const float PI = 3.1415926535;
BITMAP* buffer;
BITMAP* spritesheet;
FONT* f;
const float vel=0.01f;

int endtimer=0;

/*
 
map

 101
 101
 101
 111
 
 
 
 */
const int FRAMERATE=60;

char scoretxt[100];
int score=0;
int timeleft=40*FRAMERATE;


const int SCREEN_WIDTH=1024;
const int SCREEN_HEIGHT=768;

int lasttimesaid;
int saytimer;
int saying;

bool upheld=false;
bool downheld=false;
bool spaceheld=true;
bool leftheld=true;
bool rightheld=true;
int talkcount;
bool talking;
int curline;

const char* lines[13]=
{
"Lorem ipsum dolor sit amet, consectetuer adipiscing elit.",
"Nullam ante sapien, vestibulum nonummy, pulvinar sed, luctus ut, lacus.",
"Duis pharetra consequat dui.",
"Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.",
"Nullam vitae justo id mauris lobortis interdum.",
"Integer convallis dolor at augue iaculis malesuada.",
"Donec bibendum ipsum ut ante porta fringilla.",
"Sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.",
"Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.",
"Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.",
"Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. ",
"Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.",
"Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.",
};

const int map_w=10;
const int map_h=7;
const int TILE_SIZE=100;

int mapmask[map_h][map_w];
int controlling;

int brightness;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int endx=55; const int endy=8;


int magenta;
int red;
int pink;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;

void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 200, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-200, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];



int levelseed;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;
uint musictimer;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;

struct Pos{
	float x;
	float y;
};
Pos pos;
int control;


const int People_Count=15;
Pos peeps[10];

bool deadly[46][61];

Pos target;
bool inbase[2];

Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;



bool stoppedfather;
bool upblock;



const int T1=35;
const int T2=25;

int killtimer=0;

Pos oldmouse;
Pos newmouse;
int scoremodifier;

bool pressed[5];


void wrapprint( const string& str, int x, int y, int width=19 )
{
	
    if (width==0)
        return;
	
    string s=str+" ";
    int cury=y;
    unsigned int startp=0;
    while (startp<s.size())
    {
        int endp=startp+1;
        int lastspace=-1;
		
        while (endp-startp<=width)
        {
			
            if (endp==s.size())
            {
                lastspace=endp;
                break;
            }
            if (s[endp]=='\n')
            {
                lastspace=endp;
                break;
            }
            else if (s[endp]==' ')
            {
                lastspace=endp;
            }
            endp++;
        }
		
        if (lastspace>=0)//wrap a word around
        {
            //if two consecutive newlines
            if (s.substr(startp,lastspace-startp)=="\n")
            {
                startp=lastspace+1;
            }
            else
            {
				textout_ex(buffer, font, s.substr(startp,lastspace-startp).c_str(), x, cury, makecol(255,255,255), makecol(0,0,0));
                startp=lastspace+1;
            }
        }
        else //word bigger than line, just thunk
        {
			textout_ex(buffer, font, s.substr(startp,endp-startp).c_str(), x, cury, makecol(255,255,255), makecol(0,0,0));
            startp+=width;
        }
		
        cury+=10;
		
    }
}

int keyToIndex(int a)
{
	switch (a)
	{
		case KEY_UP:
			return 0;
		case KEY_DOWN:
			return 1;
		case KEY_LEFT:
			return 2;
		case KEY_RIGHT:
			return 3;
		case KEY_SPACE:
			return 4;
	};
	
}
void talk()
{
	
	talking=true;
	curline=rand()%13;
}

class LevelLoop
	{
	public:
		static void initialize()
		{
			sprintf(scoretxt, "%d",score);
			score=0;
			itemcount=0;
			escpressed=true;
			quit=false;
			finishedtitle=false;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			talkcount=0;
			srand(time(0));
			
			
	
			for (int i=0;i<7;i++)
				for (int j=0;j<10;j++)
				{
					mapmask[i][j]=-1;					
				}
			
			for (int a=0;a<10;a++)
			{
				int r=(rand()%(10*7-a));
				cout<<"r="<<r<<endl;
				int p=0;
				for (int i=0;i<7;i++)
					for (int j=0;j<10;j++)
					{
						if (p>=r&&mapmask[i][j]==-1)
						{
							mapmask[i][j]=a;
							goto out;
						}
						else 
							p++;
					}
				cout<<"couldn't put " <<a<<" at "<<r<<endl;
			out:
				continue;
			}
			
			for (int i=0;i<7;i++)
			{
				for (int j=0;j<10;j++)
				{
					cout<<mapmask[i][j]<<",";
				}
				cout<<endl;
			}
			
			controlling=rand()%10;	
		
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			if (key[KEY_ESC])
			{
				if (!escpressed)
				{
					quit=true;
				}
			}
			else escpressed=false;
			
			
			if (talking)
			{
				
				
				if (key[KEY_SPACE])
				{
					if (!spaceheld)
					{
						if (rand()%30==0)
						{
							talking=false;
						}
						else
						{
							curline=(curline+1+(rand()%12))%13;
						}
						spaceheld=true;
					}
				}
				else
					spaceheld=false;
				
				return;
			}			
			if (key[KEY_UP])
			{
				if (!upheld)
				{
					upheld=true;
					for (int i=0;i<10;i++)
						for (int j=1;j<7;j++)
						{
							if (mapmask[j][i]==controlling)
							{
								if (mapmask[j-1][i]==-1)
								{
									swap(mapmask[j][i],mapmask[j-1][i]);
								}
								else
								{
									talk();
								}
								goto doneup;

							}
						}
				doneup:;
				}
				else
					upheld=true;
			}
			else
				upheld=false;
			
			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					downheld=true;
					for (int i=0;i<10;i++)
						for (int j=0;j<6;j++)
						{
							if (mapmask[j][i]==controlling)
							{
								if (mapmask[j+1][i]==-1)
								{
									swap(mapmask[j][i],mapmask[j+1][i]);
								}
								else
								{
									talk();
								}
								goto donedown;
							}
						}
				donedown:;
				}
				else
					downheld=true;
			}
			else
				downheld=false;
			if (key[KEY_LEFT])
			{
				if (!leftheld)
				{
					leftheld=true;
					for (int i=1;i<10;i++)
						for (int j=0;j<7;j++)
						{
							if (mapmask[j][i]==controlling)
							{
								if (mapmask[j][i-1]==-1)
								{
									swap(mapmask[j][i-1],mapmask[j][i]);
								}
								else
								{
									talk();
								}
								goto doneleft;
							}
						}
				doneleft:;
				}
				else
					leftheld=true;
			}
			else
				leftheld=false;
			
			if (key[KEY_RIGHT])
			{
				if (!rightheld)
				{
					rightheld=true;
					for (int i=0;i<9;i++)
						for (int j=0;j<7;j++)
						{
							if (mapmask[j][i]==controlling)
							{
								if (mapmask[j][i+1]==-1)
								{
									swap(mapmask[j][i+1],mapmask[j][i]);
								}
								else
								{
									talk();
								}
								goto doneright;
							}
						}

				doneright:;
				}
				else
					rightheld=true;
			}
			else
				rightheld=false;
			
	
						
		}
		static void draw()
		{
			clear_to_color(buffer, black);
			for (int i=0;i<map_w;i++)
				for (int j=0;j<map_h;j++)
				{
					if (mapmask[j][i]>=0)
						masked_blit(spritesheet, buffer,( mapmask[j][i]%5)*TILE_SIZE,(mapmask[j][i]/5)*TILE_SIZE,i*TILE_SIZE, j*TILE_SIZE,TILE_SIZE,TILE_SIZE);
						
				}
			
			if (talking)
				wrapprint(lines[curline], 100, 100, 100);
			
		}
	};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);

		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;

		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);
			
		}
	};


class GameOverLoop
	{
	public:
		static void initialize()
		{

			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{


			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "your final score was:", 300, 5*10,white, -1);
			
			sprintf(scoretxt,"score:%d",score);
			textout_centre_ex(buffer, f, scoretxt, 300, 7*10,white, -1);
		}
	};


class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			talkcount=0;
		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

			
			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					upheld=true;
				}
			}
			else
				upheld=false;
			
			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					downheld=true;
				}
			}
			else
				downheld=false;
			
			
			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						randmusic();
						begin=true;
						endmenutimer=40;
					}
					else
					{
						randmusic();
						quit=true;
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;
			
		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,bgcol);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			textout_right_ex(buffer,f,"tuba mirum",700,40,makecol(255,255,255),-1);

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",260+50,420,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",260+50,440,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f," Start ",260+50,420,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",260+50,440,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;

template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        blit(buffer, screen, 0, 0, 0,0,SCREEN_WIDTH, SCREEN_HEIGHT);

	}
}



void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, SCREEN_WIDTH,SCREEN_HEIGHT, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	pink=makecol(255,192,203);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(0,0,0);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	spritesheet=load_bitmap("bmp/spritesheet.bmp", NULL);
	f=load_bitmap_font("bmp/font.pcx",NULL,NULL);
	if (f==0)
	{
		exit(0);
	}
	
}

int dir;
int px;
int py;

bool gototitle=false;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:
	gototitle=false;

	randmusic();
	loop<TitleLoop>();

	if (quit)
		goto end;

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}

	randmusic();
	playsample();
	loop<LevelLoop >();
	stopsample();
	
	if (finishedtitle)
		loop<GameOverLoop>();



menuskip:
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	return 0;

}
END_OF_MAIN()
